/* application.c generated by valac 0.14.2, the Vala compiler
 * generated from application.vala, do not modify */

/* vim: set tabstop=8 softtabstop=2 shiftwidth=2 expandtab: */
/*
 *    Copyright (C) 2011 Fabian Deutsch
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License along
 *    with this program; if not, write to the Free Software Foundation, Inc.,
 *    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

#include <glib.h>
#include <glib-object.h>
#include <settings.h>
#include <ui.h>
#include <libnotify/notify.h>
#include <library.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <stdio.h>


#define TYPE_APP_PRESENCE (app_presence_get_type ())
#define APP_PRESENCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_APP_PRESENCE, AppPresence))
#define APP_PRESENCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_APP_PRESENCE, AppPresenceClass))
#define IS_APP_PRESENCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_APP_PRESENCE))
#define IS_APP_PRESENCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_APP_PRESENCE))
#define APP_PRESENCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_APP_PRESENCE, AppPresenceClass))

typedef struct _AppPresence AppPresence;
typedef struct _AppPresenceClass AppPresenceClass;
typedef struct _AppPresencePrivate AppPresencePrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_option_context_free0(var) ((var == NULL) ? NULL : (var = (g_option_context_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _AppPresence {
	GObject parent_instance;
	AppPresencePrivate * priv;
};

struct _AppPresenceClass {
	GObjectClass parent_class;
};

struct _AppPresencePrivate {
	ApplicationSettings* settings;
	MainClientWindow* main_window;
	NotifyNotification* notice;
	PresenceLibPresence* provider;
};


static gpointer app_presence_parent_class = NULL;
static gchar* app_presence_uri;
static gchar* app_presence_uri = NULL;
static gboolean app_presence_is_server;
static gboolean app_presence_is_server = FALSE;
static gboolean app_presence_is_publisher;
static gboolean app_presence_is_publisher = FALSE;
static gboolean app_presence_is_not_decorated;
static gboolean app_presence_is_not_decorated = FALSE;
static gboolean app_presence_is_ipv6;
static gboolean app_presence_is_ipv6 = FALSE;
static gdouble app_presence_video_scale_factor;
static gdouble app_presence_video_scale_factor = 0.25;
static gdouble app_presence_video_quality_factor;
static gdouble app_presence_video_quality_factor = 0.5;
static gdouble app_presence_video_fps_factor;
static gdouble app_presence_video_fps_factor = 0.5;

GType app_presence_get_type (void) G_GNUC_CONST;
#define APP_PRESENCE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_APP_PRESENCE, AppPresencePrivate))
enum  {
	APP_PRESENCE_DUMMY_PROPERTY
};
AppPresence* app_presence_new (void);
AppPresence* app_presence_construct (GType object_type);
void app_presence_init (AppPresence* self, gchar*** args, int* args_length1);
static void app_presence_parse_options (AppPresence* self, gchar*** args, int* args_length1);
static void app_presence_init_ui (AppPresence* self, gchar** args, int args_length1);
static void app_presence_bind_lib_to_ui (AppPresence* self);
static void app_presence_apply_settings (AppPresence* self);
static void __lambda0_ (AppPresence* self, const gchar* s);
static void ___lambda0__presence_lib_presence_peers_discovered (PresenceLibPresence* _sender, const gchar* name, const gchar* uri, const gchar* txt, gpointer self);
static void __lambda1_ (AppPresence* self, const gchar* s);
static void ___lambda1__presence_lib_presence_peers_lost (PresenceLibPresence* _sender, const gchar* uri, gpointer self);
void app_presence_run (AppPresence* self);
static void app_presence_finalize (GObject* obj);

static const GOptionEntry APP_PRESENCE_options[9] = {{"uri", 'u', 0, G_OPTION_ARG_STRING, &app_presence_uri, "The RTSP URI to connect to.", "rtsp://127.0.0.1:8554/test"}, {"server", 's', 0, G_OPTION_ARG_NONE, &app_presence_is_server, "Provide an RSTP stream for the first device.", NULL}, {"publish", 'p', 0, G_OPTION_ARG_NONE, &app_presence_is_publisher, "Publish any RTSP stream.", NULL}, {"without-window-decorations", (gchar) 0, 0, G_OPTION_ARG_NONE, &app_presence_is_not_decorated, "Hide window decorations.", NULL}, {"ipv6", '6', 0, G_OPTION_ARG_NONE, &app_presence_is_ipv6, "Use IPv6.", NULL}, {"video-scale-factor", (gchar) 0, 0, G_OPTION_ARG_DOUBLE, &app_presence_video_scale_factor, "Factor used to scale the video (0-1).", NULL}, {"video-quality-factor", (gchar) 0, 0, G_OPTION_ARG_DOUBLE, &app_presence_video_quality_factor, "Factor used to set the compression quality of video (0-1).", NULL}, {"video-fps-factor", (gchar) 0, 0, G_OPTION_ARG_DOUBLE, &app_presence_video_fps_factor, "Factor used to set the FPS of the video (0-1).", NULL}, {NULL}};

AppPresence* app_presence_construct (GType object_type) {
	AppPresence * self = NULL;
	ApplicationSettings* _tmp0_;
	ApplicationSettings* _tmp1_;
	PresenceLibPresence* _tmp2_;
	self = (AppPresence*) g_object_new (object_type, NULL);
	_tmp0_ = application_settings_new ();
	_g_object_unref0 (self->priv->settings);
	self->priv->settings = _tmp0_;
	_tmp1_ = self->priv->settings;
	_tmp2_ = presence_lib_presence_new_with_settings (_tmp1_);
	_g_object_unref0 (self->priv->provider);
	self->priv->provider = _tmp2_;
	return self;
}


AppPresence* app_presence_new (void) {
	return app_presence_construct (TYPE_APP_PRESENCE);
}


void app_presence_init (AppPresence* self, gchar*** args, int* args_length1) {
	PresenceLibPresence* _tmp0_;
	gchar** _tmp1_;
	gint _tmp1__length1;
	g_return_if_fail (self != NULL);
	app_presence_parse_options (self, args, args_length1);
	_tmp0_ = self->priv->provider;
	presence_lib_presence_init (_tmp0_, args, args_length1);
	_tmp1_ = *args;
	_tmp1__length1 = *args_length1;
	app_presence_init_ui (self, _tmp1_, _tmp1__length1);
	app_presence_bind_lib_to_ui (self);
	app_presence_apply_settings (self);
}


static void app_presence_parse_options (AppPresence* self, gchar*** args, int* args_length1) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	{
		GOptionContext* _tmp0_;
		GOptionContext* opt_context;
		GOptionContext* _tmp1_;
		GOptionContext* _tmp2_;
		GOptionContext* _tmp3_;
		_tmp0_ = g_option_context_new ("- Show presence");
		opt_context = _tmp0_;
		_tmp1_ = opt_context;
		g_option_context_set_help_enabled (_tmp1_, TRUE);
		_tmp2_ = opt_context;
		g_option_context_add_main_entries (_tmp2_, APP_PRESENCE_options, NULL);
		_tmp3_ = opt_context;
		g_option_context_parse (_tmp3_, args_length1, args, &_inner_error_);
		if (_inner_error_ != NULL) {
			_g_option_context_free0 (opt_context);
			if (_inner_error_->domain == G_OPTION_ERROR) {
				goto __catch0_g_option_error;
			}
			_g_option_context_free0 (opt_context);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
		_g_option_context_free0 (opt_context);
	}
	goto __finally0;
	__catch0_g_option_error:
	{
		GError* e = NULL;
		FILE* _tmp4_;
		GError* _tmp5_;
		const gchar* _tmp6_;
		FILE* _tmp7_;
		gchar** _tmp8_;
		gint _tmp8__length1;
		const gchar* _tmp9_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp4_ = stdout;
		_tmp5_ = e;
		_tmp6_ = _tmp5_->message;
		fprintf (_tmp4_, "%s\n", _tmp6_);
		_tmp7_ = stdout;
		_tmp8_ = *args;
		_tmp8__length1 = *args_length1;
		_tmp9_ = _tmp8_[0];
		fprintf (_tmp7_, "Run '%s --help' to see a full list of available command line options.\n", _tmp9_);
		_g_error_free0 (e);
		return;
	}
	__finally0:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


static void app_presence_init_ui (AppPresence* self, gchar** args, int args_length1) {
	gchar** _tmp0_;
	gint _tmp0__length1;
	ApplicationSettings* _tmp1_;
	MainClientWindow* _tmp2_;
	MainClientWindow* _tmp3_;
	gboolean _tmp4_;
	g_return_if_fail (self != NULL);
	notify_init ("presence");
	_tmp0_ = args;
	_tmp0__length1 = args_length1;
	_tmp1_ = self->priv->settings;
	_tmp2_ = main_client_window_new (_tmp0_, _tmp0__length1, _tmp1_);
	_g_object_unref0 (self->priv->main_window);
	self->priv->main_window = _tmp2_;
	_tmp3_ = self->priv->main_window;
	_tmp4_ = app_presence_is_not_decorated;
	main_client_window_set_decorated (_tmp3_, !_tmp4_);
}


static void __lambda0_ (AppPresence* self, const gchar* s) {
	NotifyNotification* _tmp0_;
	NotifyNotification* _tmp1_;
	MainClientWindow* _tmp2_;
	PresenceLibPresence* _tmp3_;
	GHashTable* _tmp4_;
	GHashTable* _tmp5_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (s != NULL);
	_tmp0_ = notify_notification_new ("New peers were discovered.", "Presence discovered new peers. Use the peers dialog to connect to one " \
"of them.", "face-glasses");
	_g_object_unref0 (self->priv->notice);
	self->priv->notice = _tmp0_;
	_tmp1_ = self->priv->notice;
	notify_notification_show (_tmp1_, &_inner_error_);
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	_tmp2_ = self->priv->main_window;
	_tmp3_ = self->priv->provider;
	_tmp4_ = presence_lib_presence_get_peers (_tmp3_);
	_tmp5_ = _tmp4_;
	main_client_window_set_peers (_tmp2_, _tmp5_);
}


static void ___lambda0__presence_lib_presence_peers_discovered (PresenceLibPresence* _sender, const gchar* name, const gchar* uri, const gchar* txt, gpointer self) {
	__lambda0_ (self, name);
}


static void __lambda1_ (AppPresence* self, const gchar* s) {
	MainClientWindow* _tmp0_;
	PresenceLibPresence* _tmp1_;
	GHashTable* _tmp2_;
	GHashTable* _tmp3_;
	g_return_if_fail (s != NULL);
	_tmp0_ = self->priv->main_window;
	_tmp1_ = self->priv->provider;
	_tmp2_ = presence_lib_presence_get_peers (_tmp1_);
	_tmp3_ = _tmp2_;
	main_client_window_set_peers (_tmp0_, _tmp3_);
}


static void ___lambda1__presence_lib_presence_peers_lost (PresenceLibPresence* _sender, const gchar* uri, gpointer self) {
	__lambda1_ (self, uri);
}


static void app_presence_bind_lib_to_ui (AppPresence* self) {
	PresenceLibPresence* _tmp0_;
	PresenceLibPresence* _tmp1_;
	PresenceLibPresence* _tmp2_;
	MainClientWindow* _tmp3_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->provider;
	g_signal_connect_object (_tmp0_, "peers-discovered", (GCallback) ___lambda0__presence_lib_presence_peers_discovered, self, 0);
	_tmp1_ = self->priv->provider;
	g_signal_connect_object (_tmp1_, "peers-lost", (GCallback) ___lambda1__presence_lib_presence_peers_lost, self, 0);
	_tmp2_ = self->priv->provider;
	_tmp3_ = self->priv->main_window;
	g_object_bind_property_with_closures ((GObject*) _tmp2_, "rtsp-address", (GObject*) _tmp3_, "rtsp-address", G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, NULL)));
}


static void app_presence_apply_settings (AppPresence* self) {
	ApplicationSettings* _tmp0_;
	gboolean _tmp1_;
	ApplicationSettings* _tmp2_;
	gboolean _tmp3_;
	const gchar* _tmp4_;
	ApplicationSettings* _tmp8_;
	const gchar* _tmp9_ = NULL;
	const gchar* _tmp10_ = NULL;
	gchar* _tmp11_ = NULL;
	gchar* _tmp12_;
	ApplicationSettings* _tmp13_;
	gboolean _tmp14_;
	ApplicationSettings* _tmp15_;
	gdouble _tmp16_;
	ApplicationSettings* _tmp17_;
	gdouble _tmp18_;
	ApplicationSettings* _tmp19_;
	gdouble _tmp20_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->settings;
	_tmp1_ = app_presence_is_server;
	application_settings_set_rtsp_server_enabled (_tmp0_, _tmp1_);
	_tmp2_ = self->priv->settings;
	_tmp3_ = app_presence_is_ipv6;
	application_settings_set_ipv6 (_tmp2_, _tmp3_);
	_tmp4_ = app_presence_uri;
	if (_tmp4_ != NULL) {
		ApplicationSettings* _tmp5_;
		const gchar* _tmp6_;
		ApplicationSettings* _tmp7_;
		_tmp5_ = self->priv->settings;
		_tmp6_ = app_presence_uri;
		application_settings_set_rtsp_client_uri (_tmp5_, _tmp6_);
		_tmp7_ = self->priv->settings;
		application_settings_set_rtsp_client_enabled (_tmp7_, TRUE);
	}
	_tmp8_ = self->priv->settings;
	_tmp9_ = g_get_user_name ();
	_tmp10_ = g_get_host_name ();
	_tmp11_ = g_strdup_printf ("%s@%s", _tmp9_, _tmp10_);
	_tmp12_ = _tmp11_;
	application_settings_set_mdns_name (_tmp8_, _tmp12_);
	_g_free0 (_tmp12_);
	_tmp13_ = self->priv->settings;
	_tmp14_ = app_presence_is_publisher;
	application_settings_set_mdns_enabled (_tmp13_, _tmp14_);
	_tmp15_ = self->priv->settings;
	_tmp16_ = app_presence_video_scale_factor;
	application_settings_set_video_scale_factor (_tmp15_, _tmp16_);
	_tmp17_ = self->priv->settings;
	_tmp18_ = app_presence_video_quality_factor;
	application_settings_set_video_quality_factor (_tmp17_, _tmp18_);
	_tmp19_ = self->priv->settings;
	_tmp20_ = app_presence_video_fps_factor;
	application_settings_set_video_fps_factor (_tmp19_, _tmp20_);
}


void app_presence_run (AppPresence* self) {
	MainClientWindow* _tmp0_;
	MainClientWindow* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->main_window;
	main_client_window_show (_tmp0_);
	_tmp1_ = self->priv->main_window;
	main_client_window_run (_tmp1_);
}


static void app_presence_class_init (AppPresenceClass * klass) {
	app_presence_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (AppPresencePrivate));
	G_OBJECT_CLASS (klass)->finalize = app_presence_finalize;
}


static void app_presence_instance_init (AppPresence * self) {
	self->priv = APP_PRESENCE_GET_PRIVATE (self);
}


static void app_presence_finalize (GObject* obj) {
	AppPresence * self;
	self = APP_PRESENCE (obj);
	_g_object_unref0 (self->priv->settings);
	_g_object_unref0 (self->priv->main_window);
	_g_object_unref0 (self->priv->notice);
	_g_object_unref0 (self->priv->provider);
	G_OBJECT_CLASS (app_presence_parent_class)->finalize (obj);
}


GType app_presence_get_type (void) {
	static volatile gsize app_presence_type_id__volatile = 0;
	if (g_once_init_enter (&app_presence_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (AppPresenceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) app_presence_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AppPresence), 0, (GInstanceInitFunc) app_presence_instance_init, NULL };
		GType app_presence_type_id;
		app_presence_type_id = g_type_register_static (G_TYPE_OBJECT, "AppPresence", &g_define_type_info, 0);
		g_once_init_leave (&app_presence_type_id__volatile, app_presence_type_id);
	}
	return app_presence_type_id__volatile;
}



