/* mdns.c generated by valac 0.14.2, the Vala compiler
 * generated from mdns.vala, do not modify */

/* vim: set tabstop=8 softtabstop=2 shiftwidth=2 expandtab: */
/*
 *    Copyright (C) 2011 Fabian Deutsch
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License along
 *    with this program; if not, write to the Free Software Foundation, Inc.,
 *    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

#include <glib.h>
#include <glib-object.h>
#include <avahi-gobject/ga-entry-group.h>
#include <stdlib.h>
#include <string.h>
#include <avahi-gobject/ga-error.h>
#include <avahi-gobject/ga-client.h>
#include <avahi-gobject/ga-service-browser.h>
#include <avahi-gobject/ga-service-resolver.h>
#include <avahi-common/address.h>
#include <avahi-gobject/ga-enums.h>
#include <avahi-common/strlst.h>
#include <float.h>
#include <math.h>


#define MDNS_TYPE_MDNS_PROVIDER (mdns_mdns_provider_get_type ())
#define MDNS_MDNS_PROVIDER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MDNS_TYPE_MDNS_PROVIDER, MdnsMdnsProvider))
#define MDNS_MDNS_PROVIDER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MDNS_TYPE_MDNS_PROVIDER, MdnsMdnsProviderClass))
#define MDNS_IS_MDNS_PROVIDER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MDNS_TYPE_MDNS_PROVIDER))
#define MDNS_IS_MDNS_PROVIDER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MDNS_TYPE_MDNS_PROVIDER))
#define MDNS_MDNS_PROVIDER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MDNS_TYPE_MDNS_PROVIDER, MdnsMdnsProviderClass))

typedef struct _MdnsMdnsProvider MdnsMdnsProvider;
typedef struct _MdnsMdnsProviderClass MdnsMdnsProviderClass;
typedef struct _MdnsMdnsProviderPrivate MdnsMdnsProviderPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _MdnsMdnsProvider {
	GObject parent_instance;
	MdnsMdnsProviderPrivate * priv;
	GHashTable* available_services;
};

struct _MdnsMdnsProviderClass {
	GObjectClass parent_class;
};

struct _MdnsMdnsProviderPrivate {
	GaClient* client;
	GaEntryGroup* entry_group;
	GaEntryGroupService* published_service;
	GaServiceBrowser* service_browser;
	guint16 _port;
	gchar* _service_type;
	gchar* _txt;
	gboolean _is_published;
	gchar* _name;
	gboolean _is_ipv6;
	GaServiceResolver* service_resolver;
};


static gpointer mdns_mdns_provider_parent_class = NULL;

GaEntryGroupService* ga_entry_group_add_service (GaEntryGroup* group, const gchar* name, const gchar* type, guint16 port, GError** error, ...);
GType mdns_mdns_provider_get_type (void) G_GNUC_CONST;
#define MDNS_MDNS_PROVIDER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), MDNS_TYPE_MDNS_PROVIDER, MdnsMdnsProviderPrivate))
enum  {
	MDNS_MDNS_PROVIDER_DUMMY_PROPERTY,
	MDNS_MDNS_PROVIDER_SERVICE_TYPE,
	MDNS_MDNS_PROVIDER_TXT,
	MDNS_MDNS_PROVIDER_IS_PUBLISHED,
	MDNS_MDNS_PROVIDER_NAME,
	MDNS_MDNS_PROVIDER_IS_IPV6
};
MdnsMdnsProvider* mdns_mdns_provider_new (void);
MdnsMdnsProvider* mdns_mdns_provider_construct (GType object_type);
static void _g_free0_ (gpointer var);
static void mdns_mdns_provider_init_publish (MdnsMdnsProvider* self, GError** error);
static void mdns_mdns_provider_init_discovery (MdnsMdnsProvider* self, GError** error);
static void mdns_mdns_provider_on_is_published_changed_cb (MdnsMdnsProvider* self);
static void _mdns_mdns_provider_on_is_published_changed_cb_g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self);
const gchar* mdns_mdns_provider_get_service_type (MdnsMdnsProvider* self);
static void mdns_mdns_provider_on_new_service_cb (MdnsMdnsProvider* self, AvahiIfIndex iface, AvahiProtocol proto, const gchar* name, const gchar* type, const gchar* domain, GaLookupResultFlags flags);
static void _mdns_mdns_provider_on_new_service_cb_ga_service_browser_new_service (GaServiceBrowser* _sender, AvahiIfIndex interface, AvahiProtocol protocol, const gchar* name, const gchar* type, const gchar* domain, GaLookupResultFlags flags, gpointer self);
static void mdns_mdns_provider_on_removed_service_cb (MdnsMdnsProvider* self, AvahiIfIndex iface, AvahiProtocol proto, const gchar* name, const gchar* type, const gchar* domain, GaLookupResultFlags flags);
static void _mdns_mdns_provider_on_removed_service_cb_ga_service_browser_removed_service (GaServiceBrowser* _sender, AvahiIfIndex interface, AvahiProtocol protocol, const gchar* name, const gchar* type, const gchar* domain, GaLookupResultFlags flags, gpointer self);
static void mdns_mdns_provider_connect_debuging_handlers (MdnsMdnsProvider* self);
static void __lambda0_ (MdnsMdnsProvider* self, const gchar* name, const gchar* uri, const gchar* txt);
static void ___lambda0__mdns_mdns_provider_service_discovered (MdnsMdnsProvider* _sender, const gchar* name, const gchar* uri, const gchar* txt, gpointer self);
static void __lambda1_ (MdnsMdnsProvider* self, const gchar* name);
static void ___lambda1__mdns_mdns_provider_service_lost (MdnsMdnsProvider* _sender, const gchar* uri, gpointer self);
static void mdns_mdns_provider_publish (MdnsMdnsProvider* self, GError** error);
static void mdns_mdns_provider_unpublish (MdnsMdnsProvider* self, GError** error);
const gchar* mdns_mdns_provider_get_name (MdnsMdnsProvider* self);
guint16 mdns_mdns_provider_get_port (MdnsMdnsProvider* self);
const gchar* mdns_mdns_provider_get_txt (MdnsMdnsProvider* self);
gboolean mdns_mdns_provider_get_is_published (MdnsMdnsProvider* self);
gboolean mdns_mdns_provider_get_is_ipv6 (MdnsMdnsProvider* self);
static void mdns_mdns_provider_on_service_found_cb (MdnsMdnsProvider* self, AvahiIfIndex iface, AvahiProtocol proto, const gchar* name, const gchar* type, const gchar* domain, const gchar* host, AvahiAddress* addr, guint16 port, AvahiStringList* txt, GaLookupResultFlags flags);
static void _mdns_mdns_provider_on_service_found_cb_ga_service_resolver_found (GaServiceResolver* _sender, AvahiIfIndex interface, AvahiProtocol protocol, const gchar* name, const gchar* type, const gchar* domain, const gchar* hostname, AvahiAddress* address, guint16 port, AvahiStringList* txt, GaLookupResultFlags flags, gpointer self);
void mdns_mdns_provider_set_port (MdnsMdnsProvider* self, guint16 value);
void mdns_mdns_provider_set_service_type (MdnsMdnsProvider* self, const gchar* value);
void mdns_mdns_provider_set_txt (MdnsMdnsProvider* self, const gchar* value);
void mdns_mdns_provider_set_is_published (MdnsMdnsProvider* self, gboolean value);
void mdns_mdns_provider_set_name (MdnsMdnsProvider* self, const gchar* value);
void mdns_mdns_provider_set_is_ipv6 (MdnsMdnsProvider* self, gboolean value);
static void g_cclosure_user_marshal_VOID__STRING_STRING_STRING (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void mdns_mdns_provider_finalize (GObject* obj);
static void _vala_mdns_mdns_provider_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_mdns_mdns_provider_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


static void _g_free0_ (gpointer var) {
	var = (g_free (var), NULL);
}


MdnsMdnsProvider* mdns_mdns_provider_construct (GType object_type) {
	MdnsMdnsProvider * self = NULL;
	GHashFunc _tmp0_;
	GEqualFunc _tmp1_;
	GHashTable* _tmp2_;
	GaClient* _tmp3_;
	GError * _inner_error_ = NULL;
	self = (MdnsMdnsProvider*) g_object_new (object_type, NULL);
	_tmp0_ = g_str_hash;
	_tmp1_ = g_str_equal;
	_tmp2_ = g_hash_table_new_full (_tmp0_, _tmp1_, _g_free0_, _g_free0_);
	_g_hash_table_unref0 (self->available_services);
	self->available_services = _tmp2_;
	_tmp3_ = ga_client_new (GA_CLIENT_FLAG_NO_FLAGS);
	_g_object_unref0 (self->priv->client);
	self->priv->client = _tmp3_;
	{
		GaClient* _tmp4_;
		_tmp4_ = self->priv->client;
		ga_client_start (_tmp4_, &_inner_error_);
		if (_inner_error_ != NULL) {
			goto __catch0_g_error;
		}
		mdns_mdns_provider_init_publish (self, &_inner_error_);
		if (_inner_error_ != NULL) {
			goto __catch0_g_error;
		}
		mdns_mdns_provider_init_discovery (self, &_inner_error_);
		if (_inner_error_ != NULL) {
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp5_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp5_ = e->message;
		g_error ("mdns.vala:105: An error occured while setting up MDNS: %s", _tmp5_);
		_g_error_free0 (e);
	}
	__finally0:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	return self;
}


MdnsMdnsProvider* mdns_mdns_provider_new (void) {
	return mdns_mdns_provider_construct (MDNS_TYPE_MDNS_PROVIDER);
}


static void _mdns_mdns_provider_on_is_published_changed_cb_g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self) {
	mdns_mdns_provider_on_is_published_changed_cb (self);
}


static void mdns_mdns_provider_init_publish (MdnsMdnsProvider* self, GError** error) {
	GaEntryGroup* _tmp0_;
	GaEntryGroup* _tmp1_;
	GaClient* _tmp2_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = ga_entry_group_new ();
	_g_object_unref0 (self->priv->entry_group);
	self->priv->entry_group = _tmp0_;
	_tmp1_ = self->priv->entry_group;
	_tmp2_ = self->priv->client;
	ga_entry_group_attach (_tmp1_, _tmp2_, &_inner_error_);
	if (_inner_error_ != NULL) {
		if (_inner_error_->domain == GA_ERROR) {
			g_propagate_error (error, _inner_error_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	g_signal_connect_object ((GObject*) self, "notify::is-published", (GCallback) _mdns_mdns_provider_on_is_published_changed_cb_g_object_notify, self, 0);
}


static void _mdns_mdns_provider_on_new_service_cb_ga_service_browser_new_service (GaServiceBrowser* _sender, AvahiIfIndex interface, AvahiProtocol protocol, const gchar* name, const gchar* type, const gchar* domain, GaLookupResultFlags flags, gpointer self) {
	mdns_mdns_provider_on_new_service_cb (self, interface, protocol, name, type, domain, flags);
}


static void _mdns_mdns_provider_on_removed_service_cb_ga_service_browser_removed_service (GaServiceBrowser* _sender, AvahiIfIndex interface, AvahiProtocol protocol, const gchar* name, const gchar* type, const gchar* domain, GaLookupResultFlags flags, gpointer self) {
	mdns_mdns_provider_on_removed_service_cb (self, interface, protocol, name, type, domain, flags);
}


static void mdns_mdns_provider_init_discovery (MdnsMdnsProvider* self, GError** error) {
	const gchar* _tmp0_;
	GaServiceBrowser* _tmp1_;
	GaServiceBrowser* _tmp2_;
	GaServiceBrowser* _tmp3_;
	GaServiceBrowser* _tmp4_;
	GaClient* _tmp5_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_service_type;
	_tmp1_ = ga_service_browser_new (_tmp0_);
	_g_object_unref0 (self->priv->service_browser);
	self->priv->service_browser = _tmp1_;
	_tmp2_ = self->priv->service_browser;
	g_signal_connect_object (_tmp2_, "new-service", (GCallback) _mdns_mdns_provider_on_new_service_cb_ga_service_browser_new_service, self, 0);
	_tmp3_ = self->priv->service_browser;
	g_signal_connect_object (_tmp3_, "removed-service", (GCallback) _mdns_mdns_provider_on_removed_service_cb_ga_service_browser_removed_service, self, 0);
	_tmp4_ = self->priv->service_browser;
	_tmp5_ = self->priv->client;
	ga_service_browser_attach (_tmp4_, _tmp5_, &_inner_error_);
	if (_inner_error_ != NULL) {
		if (_inner_error_->domain == GA_ERROR) {
			g_propagate_error (error, _inner_error_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


static void __lambda0_ (MdnsMdnsProvider* self, const gchar* name, const gchar* uri, const gchar* txt) {
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	g_return_if_fail (name != NULL);
	g_return_if_fail (uri != NULL);
	g_return_if_fail (txt != NULL);
	_tmp0_ = name;
	_tmp1_ = uri;
	_tmp2_ = txt;
	g_debug ("mdns.vala:135: Discovered %s (%s)\n%s", _tmp0_, _tmp1_, _tmp2_);
}


static void ___lambda0__mdns_mdns_provider_service_discovered (MdnsMdnsProvider* _sender, const gchar* name, const gchar* uri, const gchar* txt, gpointer self) {
	__lambda0_ (self, name, uri, txt);
}


static void __lambda1_ (MdnsMdnsProvider* self, const gchar* name) {
	const gchar* _tmp0_;
	g_return_if_fail (name != NULL);
	_tmp0_ = name;
	g_debug ("mdns.vala:138: Lost %s", _tmp0_);
}


static void ___lambda1__mdns_mdns_provider_service_lost (MdnsMdnsProvider* _sender, const gchar* uri, gpointer self) {
	__lambda1_ (self, uri);
}


static void mdns_mdns_provider_connect_debuging_handlers (MdnsMdnsProvider* self) {
	g_return_if_fail (self != NULL);
	g_signal_connect_object (self, "service-discovered", (GCallback) ___lambda0__mdns_mdns_provider_service_discovered, self, 0);
	g_signal_connect_object (self, "service-lost", (GCallback) ___lambda1__mdns_mdns_provider_service_lost, self, 0);
}


static void mdns_mdns_provider_publish (MdnsMdnsProvider* self, GError** error) {
	GaEntryGroupService* _tmp0_;
	GaEntryGroup* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	guint16 _tmp4_;
	const gchar* _tmp5_;
	GaEntryGroupService* _tmp6_ = NULL;
	GaEntryGroupService* _tmp7_;
	GaEntryGroup* _tmp8_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->published_service;
	if (_tmp0_ != NULL) {
		mdns_mdns_provider_unpublish (self, &_inner_error_);
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == GA_ERROR) {
				g_propagate_error (error, _inner_error_);
				return;
			} else {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
		}
	}
	_tmp1_ = self->priv->entry_group;
	_tmp2_ = self->priv->_name;
	_tmp3_ = self->priv->_service_type;
	_tmp4_ = self->priv->_port;
	_tmp5_ = self->priv->_txt;
	_tmp6_ = ga_entry_group_add_service (_tmp1_, _tmp2_, _tmp3_, _tmp4_, &_inner_error_, _tmp5_, NULL);
	_tmp7_ = _tmp6_;
	if (_inner_error_ != NULL) {
		if (_inner_error_->domain == GA_ERROR) {
			g_propagate_error (error, _inner_error_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	self->priv->published_service = _tmp7_;
	_tmp8_ = self->priv->entry_group;
	ga_entry_group_commit (_tmp8_, &_inner_error_);
	if (_inner_error_ != NULL) {
		if (_inner_error_->domain == GA_ERROR) {
			g_propagate_error (error, _inner_error_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


static void mdns_mdns_provider_unpublish (MdnsMdnsProvider* self, GError** error) {
	GaEntryGroup* _tmp0_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->entry_group;
	ga_entry_group_reset (_tmp0_, &_inner_error_);
	if (_inner_error_ != NULL) {
		if (_inner_error_->domain == GA_ERROR) {
			g_propagate_error (error, _inner_error_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


static void mdns_mdns_provider_on_is_published_changed_cb (MdnsMdnsProvider* self) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	{
		gboolean _tmp0_;
		_tmp0_ = self->priv->_is_published;
		if (_tmp0_) {
			mdns_mdns_provider_publish (self, &_inner_error_);
			if (_inner_error_ != NULL) {
				goto __catch1_g_error;
			}
		} else {
			mdns_mdns_provider_unpublish (self, &_inner_error_);
			if (_inner_error_ != NULL) {
				goto __catch1_g_error;
			}
		}
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp1_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp1_ = e->message;
		g_error ("mdns.vala:184: An error occured while toggling publishing: %s", _tmp1_);
		_g_error_free0 (e);
	}
	__finally1:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


static void _mdns_mdns_provider_on_service_found_cb_ga_service_resolver_found (GaServiceResolver* _sender, AvahiIfIndex interface, AvahiProtocol protocol, const gchar* name, const gchar* type, const gchar* domain, const gchar* hostname, AvahiAddress* address, guint16 port, AvahiStringList* txt, GaLookupResultFlags flags, gpointer self) {
	mdns_mdns_provider_on_service_found_cb (self, interface, protocol, name, type, domain, hostname, address, port, txt, flags);
}


static void mdns_mdns_provider_on_new_service_cb (MdnsMdnsProvider* self, AvahiIfIndex iface, AvahiProtocol proto, const gchar* name, const gchar* type, const gchar* domain, GaLookupResultFlags flags) {
	AvahiProtocol _tmp0_ = 0;
	gboolean _tmp1_;
	AvahiProtocol _tmp2_;
	AvahiProtocol req_proto;
	AvahiIfIndex _tmp3_;
	AvahiProtocol _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	GaServiceResolver* _tmp8_;
	GaServiceResolver* _tmp9_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (name != NULL);
	g_return_if_fail (type != NULL);
	g_return_if_fail (domain != NULL);
	_tmp1_ = self->priv->_is_ipv6;
	if (_tmp1_) {
		_tmp0_ = AVAHI_PROTO_INET6;
	} else {
		_tmp0_ = AVAHI_PROTO_INET;
	}
	_tmp2_ = _tmp0_;
	req_proto = _tmp2_;
	_tmp3_ = iface;
	_tmp4_ = proto;
	_tmp5_ = name;
	_tmp6_ = type;
	_tmp7_ = domain;
	_tmp8_ = ga_service_resolver_new (_tmp3_, _tmp4_, _tmp5_, _tmp6_, _tmp7_, req_proto, GA_LOOKUP_NO_FLAGS);
	_g_object_unref0 (self->priv->service_resolver);
	self->priv->service_resolver = _tmp8_;
	_tmp9_ = self->priv->service_resolver;
	g_signal_connect_object (_tmp9_, "found", (GCallback) _mdns_mdns_provider_on_service_found_cb_ga_service_resolver_found, self, 0);
	{
		GaServiceResolver* _tmp10_;
		GaClient* _tmp11_;
		_tmp10_ = self->priv->service_resolver;
		_tmp11_ = self->priv->client;
		ga_service_resolver_attach (_tmp10_, _tmp11_, &_inner_error_);
		if (_inner_error_ != NULL) {
			goto __catch2_g_error;
		}
	}
	goto __finally2;
	__catch2_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp12_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp12_ = e->message;
		g_error ("mdns.vala:211: Could not attach resolver: %s", _tmp12_);
		_g_error_free0 (e);
	}
	__finally2:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


static void mdns_mdns_provider_on_removed_service_cb (MdnsMdnsProvider* self, AvahiIfIndex iface, AvahiProtocol proto, const gchar* name, const gchar* type, const gchar* domain, GaLookupResultFlags flags) {
	GHashTable* _tmp0_;
	const gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
	g_return_if_fail (self != NULL);
	g_return_if_fail (name != NULL);
	g_return_if_fail (type != NULL);
	g_return_if_fail (domain != NULL);
	_tmp0_ = self->available_services;
	_tmp1_ = name;
	_tmp2_ = g_hash_table_remove (_tmp0_, _tmp1_);
	if (_tmp2_) {
		const gchar* _tmp3_;
		_tmp3_ = name;
		g_signal_emit_by_name (self, "service-lost", _tmp3_);
	}
}


static void mdns_mdns_provider_on_service_found_cb (MdnsMdnsProvider* self, AvahiIfIndex iface, AvahiProtocol proto, const gchar* name, const gchar* type, const gchar* domain, const gchar* host, AvahiAddress* addr, guint16 port, AvahiStringList* txt, GaLookupResultFlags flags) {
	AvahiAddress* _tmp0_;
	gsize _tmp1_;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_;
	gint _tmp3__length1;
	const gchar* _tmp4_ = NULL;
	guint16 _tmp5_;
	AvahiStringList* _tmp6_;
	gchar* _tmp7_;
	gint _tmp7__length1;
	gchar* _tmp8_ = NULL;
	gchar* _tmp9_;
	gchar* uri;
	gboolean _tmp10_;
	GHashTable* _tmp20_;
	const gchar* _tmp21_;
	gchar* _tmp22_;
	const gchar* _tmp23_;
	gchar* _tmp24_;
	const gchar* _tmp25_;
	const gchar* _tmp26_;
	AvahiStringList* _tmp27_;
	gchar* _tmp28_ = NULL;
	gchar* _tmp29_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (name != NULL);
	g_return_if_fail (type != NULL);
	g_return_if_fail (domain != NULL);
	g_return_if_fail (host != NULL);
	_tmp0_ = addr;
	_tmp1_ = AVAHI_ADDRESS_STR_MAX;
	_tmp2_ = g_new0 (gchar, _tmp1_);
	_tmp3_ = _tmp2_;
	_tmp3__length1 = _tmp1_;
	_tmp4_ = avahi_address_snprint (_tmp3_, _tmp1_, _tmp0_);
	_tmp5_ = port;
	_tmp6_ = txt;
	_tmp7_ = _tmp6_->text;
	_tmp7__length1 = _tmp6_->size;
	_tmp8_ = g_strdup_printf ("rtsp://%s:%g/%s", _tmp4_, (gdouble) _tmp5_, (const gchar*) _tmp7_);
	_tmp9_ = _tmp8_;
	_tmp3_ = (g_free (_tmp3_), NULL);
	uri = _tmp9_;
	_tmp10_ = self->priv->_is_ipv6;
	if (_tmp10_) {
		AvahiAddress* _tmp11_;
		gsize _tmp12_;
		gchar* _tmp13_ = NULL;
		gchar* _tmp14_;
		gint _tmp14__length1;
		const gchar* _tmp15_ = NULL;
		guint16 _tmp16_;
		AvahiStringList* _tmp17_;
		gchar* _tmp18_;
		gint _tmp18__length1;
		gchar* _tmp19_ = NULL;
		_tmp11_ = addr;
		_tmp12_ = AVAHI_ADDRESS_STR_MAX;
		_tmp13_ = g_new0 (gchar, _tmp12_);
		_tmp14_ = _tmp13_;
		_tmp14__length1 = _tmp1_;
		_tmp15_ = avahi_address_snprint (_tmp14_, _tmp1_, _tmp11_);
		_tmp16_ = port;
		_tmp17_ = txt;
		_tmp18_ = _tmp17_->text;
		_tmp18__length1 = _tmp17_->size;
		_tmp19_ = g_strdup_printf ("rtsp://[%s]:%g/%s", _tmp15_, (gdouble) _tmp16_, (const gchar*) _tmp18_);
		_g_free0 (uri);
		uri = _tmp19_;
		_tmp14_ = (g_free (_tmp14_), NULL);
	}
	_tmp20_ = self->available_services;
	_tmp21_ = name;
	_tmp22_ = g_strdup (_tmp21_);
	_tmp23_ = uri;
	_tmp24_ = g_strdup (_tmp23_);
	g_hash_table_insert (_tmp20_, _tmp22_, _tmp24_);
	_tmp25_ = name;
	_tmp26_ = uri;
	_tmp27_ = txt;
	_tmp28_ = avahi_string_list_to_string (_tmp27_);
	_tmp29_ = _tmp28_;
	g_signal_emit_by_name (self, "service-discovered", _tmp25_, _tmp26_, _tmp29_);
	_g_free0 (_tmp29_);
	_g_free0 (uri);
}


guint16 mdns_mdns_provider_get_port (MdnsMdnsProvider* self) {
	guint16 result;
	guint16 _tmp0_;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = self->priv->_port;
	result = _tmp0_;
	return result;
}


void mdns_mdns_provider_set_port (MdnsMdnsProvider* self, guint16 value) {
	guint16 _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_port = _tmp0_;
}


const gchar* mdns_mdns_provider_get_service_type (MdnsMdnsProvider* self) {
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_service_type;
	result = _tmp0_;
	return result;
}


void mdns_mdns_provider_set_service_type (MdnsMdnsProvider* self, const gchar* value) {
	const gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_service_type);
	self->priv->_service_type = _tmp1_;
	g_object_notify ((GObject *) self, "service-type");
}


const gchar* mdns_mdns_provider_get_txt (MdnsMdnsProvider* self) {
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_txt;
	result = _tmp0_;
	return result;
}


void mdns_mdns_provider_set_txt (MdnsMdnsProvider* self, const gchar* value) {
	const gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_txt);
	self->priv->_txt = _tmp1_;
	g_object_notify ((GObject *) self, "txt");
}


gboolean mdns_mdns_provider_get_is_published (MdnsMdnsProvider* self) {
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_is_published;
	result = _tmp0_;
	return result;
}


void mdns_mdns_provider_set_is_published (MdnsMdnsProvider* self, gboolean value) {
	gboolean _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_is_published = _tmp0_;
	g_object_notify ((GObject *) self, "is-published");
}


const gchar* mdns_mdns_provider_get_name (MdnsMdnsProvider* self) {
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_name;
	result = _tmp0_;
	return result;
}


void mdns_mdns_provider_set_name (MdnsMdnsProvider* self, const gchar* value) {
	const gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_name);
	self->priv->_name = _tmp1_;
	g_object_notify ((GObject *) self, "name");
}


gboolean mdns_mdns_provider_get_is_ipv6 (MdnsMdnsProvider* self) {
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_is_ipv6;
	result = _tmp0_;
	return result;
}


void mdns_mdns_provider_set_is_ipv6 (MdnsMdnsProvider* self, gboolean value) {
	gboolean _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_is_ipv6 = _tmp0_;
	g_object_notify ((GObject *) self, "is-ipv6");
}


static void g_cclosure_user_marshal_VOID__STRING_STRING_STRING (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__STRING_STRING_STRING) (gpointer data1, const char* arg_1, const char* arg_2, const char* arg_3, gpointer data2);
	register GMarshalFunc_VOID__STRING_STRING_STRING callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 4);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__STRING_STRING_STRING) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_string (param_values + 1), g_value_get_string (param_values + 2), g_value_get_string (param_values + 3), data2);
}


static void mdns_mdns_provider_class_init (MdnsMdnsProviderClass * klass) {
	mdns_mdns_provider_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (MdnsMdnsProviderPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_mdns_mdns_provider_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_mdns_mdns_provider_set_property;
	G_OBJECT_CLASS (klass)->finalize = mdns_mdns_provider_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), MDNS_MDNS_PROVIDER_SERVICE_TYPE, g_param_spec_string ("service-type", "service-type", "service-type", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MDNS_MDNS_PROVIDER_TXT, g_param_spec_string ("txt", "txt", "txt", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MDNS_MDNS_PROVIDER_IS_PUBLISHED, g_param_spec_boolean ("is-published", "is-published", "is-published", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MDNS_MDNS_PROVIDER_NAME, g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MDNS_MDNS_PROVIDER_IS_IPV6, g_param_spec_boolean ("is-ipv6", "is-ipv6", "is-ipv6", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_signal_new ("service_discovered", MDNS_TYPE_MDNS_PROVIDER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_STRING_STRING, G_TYPE_NONE, 3, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING);
	g_signal_new ("service_lost", MDNS_TYPE_MDNS_PROVIDER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
}


static void mdns_mdns_provider_instance_init (MdnsMdnsProvider * self) {
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	self->priv = MDNS_MDNS_PROVIDER_GET_PRIVATE (self);
	self->priv->_port = (guint16) 8554;
	_tmp0_ = g_strdup ("_rtsp._tcp");
	self->priv->_service_type = _tmp0_;
	_tmp1_ = g_strdup ("presence");
	self->priv->_txt = _tmp1_;
	self->priv->_is_published = FALSE;
	_tmp2_ = g_strdup ("no-name-yet");
	self->priv->_name = _tmp2_;
	self->priv->_is_ipv6 = FALSE;
}


static void mdns_mdns_provider_finalize (GObject* obj) {
	MdnsMdnsProvider * self;
	self = MDNS_MDNS_PROVIDER (obj);
	_g_object_unref0 (self->priv->service_resolver);
	self->priv->service_resolver = NULL;
	_g_object_unref0 (self->priv->client);
	_g_object_unref0 (self->priv->entry_group);
	_g_object_unref0 (self->priv->service_browser);
	_g_hash_table_unref0 (self->available_services);
	_g_free0 (self->priv->_service_type);
	_g_free0 (self->priv->_txt);
	_g_free0 (self->priv->_name);
	_g_object_unref0 (self->priv->service_resolver);
	G_OBJECT_CLASS (mdns_mdns_provider_parent_class)->finalize (obj);
}


/**
   * Handles MDNS based publishing and discovery.
   */
GType mdns_mdns_provider_get_type (void) {
	static volatile gsize mdns_mdns_provider_type_id__volatile = 0;
	if (g_once_init_enter (&mdns_mdns_provider_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (MdnsMdnsProviderClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) mdns_mdns_provider_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MdnsMdnsProvider), 0, (GInstanceInitFunc) mdns_mdns_provider_instance_init, NULL };
		GType mdns_mdns_provider_type_id;
		mdns_mdns_provider_type_id = g_type_register_static (G_TYPE_OBJECT, "MdnsMdnsProvider", &g_define_type_info, 0);
		g_once_init_leave (&mdns_mdns_provider_type_id__volatile, mdns_mdns_provider_type_id);
	}
	return mdns_mdns_provider_type_id__volatile;
}


static void _vala_mdns_mdns_provider_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	MdnsMdnsProvider * self;
	self = MDNS_MDNS_PROVIDER (object);
	switch (property_id) {
		case MDNS_MDNS_PROVIDER_SERVICE_TYPE:
		g_value_set_string (value, mdns_mdns_provider_get_service_type (self));
		break;
		case MDNS_MDNS_PROVIDER_TXT:
		g_value_set_string (value, mdns_mdns_provider_get_txt (self));
		break;
		case MDNS_MDNS_PROVIDER_IS_PUBLISHED:
		g_value_set_boolean (value, mdns_mdns_provider_get_is_published (self));
		break;
		case MDNS_MDNS_PROVIDER_NAME:
		g_value_set_string (value, mdns_mdns_provider_get_name (self));
		break;
		case MDNS_MDNS_PROVIDER_IS_IPV6:
		g_value_set_boolean (value, mdns_mdns_provider_get_is_ipv6 (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_mdns_mdns_provider_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	MdnsMdnsProvider * self;
	self = MDNS_MDNS_PROVIDER (object);
	switch (property_id) {
		case MDNS_MDNS_PROVIDER_SERVICE_TYPE:
		mdns_mdns_provider_set_service_type (self, g_value_get_string (value));
		break;
		case MDNS_MDNS_PROVIDER_TXT:
		mdns_mdns_provider_set_txt (self, g_value_get_string (value));
		break;
		case MDNS_MDNS_PROVIDER_IS_PUBLISHED:
		mdns_mdns_provider_set_is_published (self, g_value_get_boolean (value));
		break;
		case MDNS_MDNS_PROVIDER_NAME:
		mdns_mdns_provider_set_name (self, g_value_get_string (value));
		break;
		case MDNS_MDNS_PROVIDER_IS_IPV6:
		mdns_mdns_provider_set_is_ipv6 (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



